void irem() 
{
   if (irrecv.decode(&results)) {
   // Serial.println(results.value, HEX);
    irrecv.resume(); // Receive the next value
    digitalWrite(13, HIGH);
//on off E10332D
//photo E106678
//display E10EAF4
//datatime E10E6F8
//audiodub E10908E
//play E10504E
//rew E10405E
//FF E10C0DE
//pause E10607E
//stop E10001E
//leftstill E10E0FE
//rightstill E10F0EE
//menu E106A74
//enter E101A04
//right E904BD5
//left E90CB55
//up E900B95
//down E908B15
//search E90019F
//zoom T E104658
//zoom W E10C6D8


if(results.value == 0xE10504E) //play
{
mode=0;
  for (int i = 0; i < NUM_LEDS; i++)
  {
   leds[i] = CRGB::White; // Белый цвет.
    FastLED.show();
  }
}

if(results.value == 0xE10001E)// stop 
{
 mode=0;
  for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB::Black; // OFF.
    FastLED.show();
  }
}

if(results.value == 0xE10E0FE) //leftstill E10E0FE
{
    if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(130, 70, 250)); // Сине-фиолетовый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(130, 70, 250)); // Сине-фиолетовый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(130, 70, 250)); // Сине-фиолетовый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
}
if(results.value == 0xE10F0EE) //rightstill E10F0EE
{
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(180, 110,190)); // Сиреневый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(180, 110,190)); // Сиреневый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(180, 110,190)); // Сиреневый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }


if(results.value == 0xE101A04) //enter E101A04
{
  //if(curm==0){curm=1;}
//curm=1;
}

//display E10EAF4
if(results.value == 0xE10EAF4) //display
{
//settimer=1;
menu=2;
}






if(results.value == 0xE10E6F8) //datatime E10E6F8
{settim=1;
}
if(results.value == 0xE90019F) //search E90019F
{ustt1=1;
}

if(results.value == 0xE10405E) //rew E10405E
{//timer1();
 mode=7;//закат
  s=1;
}

if(results.value == 0xE10C0DE) //ff
{
   mode=6;//рассвет
  s=1;
}
//*******************



if(results.value == 0xE106678) //E106678 foto
{//nigtset ();
menu=5;
}
//******************************
if(results.value == 0xE908B15) //down
{
if(curm==1){n1=!n1;}
if(curm==2){n2=!n2;}
if(curm==3){n3=!n3;}
if(curm==4){n4=!n4;}
if(curm==5){n5=!n5;}
if(curm==6)
      {l1=l1-1;
        if(l1<0){l1=0;}
       }
if(curm==7)
      {l2=l2-1;
        if(l2<0){l2=0;}
       }
 if(curm==8)
      {l3=l3-1;
        if(l3<0){l3=0;}
       }
if(curm>5)
     {ulamp ();
     }
     else
     {uprav ();
     }
}
if(results.value == 0xE900B95) //up E900B95
{
if(curm==1){n1=!n1;}
if(curm==2){n2=!n2;}
if(curm==3){n3=!n3;}
if(curm==4){n4=!n4;}
if(curm==5){n5=!n5;}
if(curm==6)
      {l1=l1+1;
        if(l1>100){l1=100;}
       }
 if(curm==7)
      {l2=l2+1;
        if(l2>100){l2=100;}
       }
 if(curm==8)
      {l3=l3+1;
        if(l3>100){l3=100;}
       }

if(curm>5)
     {ulamp ();
     }
     else
     {uprav ();
     }

}


if(results.value == 0xE10908E) //audio
{
  //lampse=1;
  n5=0;// флаг таймера
  fn=0;// флаг принуд вкл
  digitalWrite(6, LOW);   // выключает 5 timer
analogWrite(12,0);//выкл ламп
analogWrite(8,0);
}



if(results.value == 0xE90CB55) //left
{ curm--;
  if(curm<1){curm=8;}
}


if(results.value == 0xE904BD5)//right 
{curm++;
  if(curm>8){curm=1;}
}





if(results.value == 0xE106A74) //menu
{
//menu=0;
   if(curm>0){
           curm=0;
           nagruz ();
           ulamp ();
          }
}


if(results.value == 0xE10332D) //on off
//zoom W 10C6D8
{

}

if(results.value == 0xE104658) //zoom T 104658+
//zoom W 10C6D8
{
  //analogWrite(8,250);
  n5=1;// флаг таймера
  fn=1;// флаг принуд вкл
  digitalWrite(6, HIGH);   // включает 5 timer
analogWrite(12,100);
}

if(results.value == 0xE10C6D8) //zoom W 10C6D8-

{n5=1;// флаг таймера
fn=1;// флаг принуд вкл
  digitalWrite(6, HIGH);   // включает 5 timer
  analogWrite(8,250);
//analogWrite(12,250);
}
//*****************************************************************************************************
 if (results.value == 0xFFB24D) { //FLASH
  mode=1;
  s=1;
 }  
  if (results.value == 0xFF00FF) { //STROBE
   mode=2;

   s=1;
  }
 
  if (results.value == 0xFF58A7) { //FADE 
  mode=6;
  s=1;
 }
   if (results.value == 0xFF30CF) { //FADE 
  mode=7;
  s=1;
 }
 
 
//************************************OFF*************************       
 if (results.value == 0xFFF807) { 
 mode=0;
  for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB::Black; // OFF.
    FastLED.show();
  }
   }      
   //************************************On*************************       
 if (results.value == 0xFFB04F) { 
 mode=0;
  for (int i = 0; i < NUM_LEDS; i++)
  {
   leds[i] = CRGB::White; // Белый цвет.
    FastLED.show();
  }
   }     
//************************************ ↑ *************************    
 if (results.value == 0xFF906F) 
 { 

   int b=20;
  if (new_bright_f<100)
  {b=10;
  }
  if (new_bright_f<50)
  {b=5;
  }
  if (new_bright_f<10)
  {b=1;
  }
    new_bright_f=new_bright_f+b;
  if(new_bright_f>max_bright)
  {
new_bright_f=max_bright;
  }
 LEDS.setBrightness(new_bright_f);      // установить новую яркость
    FastLED.show();
   
 

 }  
  
//************************************ ↓ *************************    
 if (results.value == 0xFFB847) 
 {
 
 int b=20;
  if (new_bright_f<100)
  {b=10;
  }
  if (new_bright_f<50)
  {b=5;
  }
  if (new_bright_f<10)
  {b=1;
  }
  new_bright_f=new_bright_f-b;
   if(new_bright_f<min_bright)
  {
new_bright_f=min_bright;
  }

    LEDS.setBrightness(new_bright_f);      // установить новую яркость
    FastLED.show();

 }      
//********************************RED************************
 if (results.value == 0xFF9867) { 
if(mode==0)
{
  for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB::Red; // Красный цвет.
    FastLED.show();
  }
}
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
    leds[i] = CRGB::Red; // 
    FastLED.show();
  }
}
   if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = CRGB::Red; //
    //leds[3] = CRGB::Red; //
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }
//*****************************GREEN*************************
 if (results.value == 0xFFD827) { 
if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB::Green; // Зеленый цвет.
    FastLED.show();
  }
 }
   if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = CRGB::Green; // Зеленый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = CRGB::Green; // Зеленый цвет.
    //leds[3] = CRGB::Green; // Зеленый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;

}  
//*****************************BLUE*************************
 if (results.value == 0xFF8877) {
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB::Blue; // Синий цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = CRGB::Blue; // Синий цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] =  CRGB::Blue; // Синий цвет.
    //leds[3] =  CRGB::Blue; // Синий цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }
//*****************************White*************************
 if (results.value == 0xFFA857) {  
   
   if(mode==6)mode=1;
   if(mode==7)mode=1;
  if(mode==0)
  {
    for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB::White; // Белый цвет.
    FastLED.show();
  }
   }
   
    if(mode==1)
  {
    for (int i = 0; i < NUM_LEDS; i=i+2)
  {
    leds[i] = CRGB::White; // Белый цвет.
    FastLED.show();
  }
   }
      if(mode==2)
  {
    for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = CRGB::White; // Белый цвет.
    FastLED.show();
  }
   }
   
   
   
 }
   //*****************************ORANGE*************************
if (results.value == 0xFFE817) { 
  if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(255, 50,0)); // Оранжевый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(255, 50,0)); // Оранжевый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(255, 50,0)); // Оранжевый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

      //*****************************AQUA*************************
 if (results.value == 0xFF48B7) { 
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB::Aqua; // Бирюзовый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
   leds[i] = CRGB::Aqua; // Бирюзовый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = CRGB::Aqua; // Бирюзовый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

         //*****************************Сине-фиолетовый*************************
 if (results.value == 0xFF6897) { 
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(100, 30, 220)); // Сине-фиолетовый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(100, 30, 220)); // Сине-фиолетовый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(100, 30, 220)); // Сине-фиолетовый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

       //*****************************Светло-оранжевый*************************
 if (results.value == 0xFF02FD) { 
  if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(255, 80,20)); // Светло-оранжевый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(255, 80,20)); // Светло-оранжевый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
   leds[i] = (CRGB(255, 80,20)); // Светло-оранжевый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

//*****************************Тёмно-берюзовый*************************
 if (results.value == 0xFF32CD) { 
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(59,131,189)); // Тёмно-берюзовый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(59,131,189)); // Тёмно-берюзовый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(59,131,189)); // Тёмно-берюзовый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

//*****************************Фиолетовый*************************
 if (results.value == 0xFF20DF) { 
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(139,0,255)); // Фиолетовый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(139,0,255)); // Фиолетовый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(139,0,255)); // Фиолетовый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

//*****************************Тёмно-жёлтый*************************
 if (results.value == 0xFF50AF) { 
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(250, 100,10)); // Тёмно-жёлтый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
   leds[i] = (CRGB(250, 100,10)); // Тёмно-жёлтый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
   leds[i] = (CRGB(250, 100,10)); // Тёмно-жёлтый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }
     
//*****************************Голубой*************************
 if (results.value == 0xFF7887) { 
  if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(0, 97,255)); // Голубой цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
    leds[i] = (CRGB(0, 97,255)); // Голубой цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
   leds[i] = (CRGB(0, 97,255)); // Голубой цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

//*****************************Сиреневый*************************
 if (results.value == 0xFF708F) { 
  if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(80, 10,90)); // Сиреневый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(80, 10,90)); // Сиреневый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(80, 10,90)); // Сиреневый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }

//*****************************Лимонный*************************
 if (results.value == 0xFF38C7) { 
 if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
   leds[i] = (CRGB(253, 233,16)); // Лимонный
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
    leds[i] = (CRGB(253, 233,16)); // Лимонный
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
  leds[i] = (CRGB(253, 233,16)); // Лимонный
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
 }
 
//*****************************Светло-голубой*************************
 if (results.value == 0xFF28D7) { 
   if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
   leds[i] = (CRGB(135, 206,250)); // Светло-голубой цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
    leds[i] = (CRGB(135, 206,250)); // Светло-голубой цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
    leds[i] = (CRGB(135, 206,250)); // Светло-голубой цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
 }

//*****************************Розовый*************************
 if (results.value == 0xFFF00F) { 
 if(mode==0)
 { for (int i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = (CRGB(150, 10,150)); // Розовый цвет.
    FastLED.show();
  }  
 }
  if(mode==1)
{
 for (int i = 0; i < NUM_LEDS; i=i+2)
  {
     leds[i] = (CRGB(150, 10,150)); // Розовый цвет.
    FastLED.show();
  }
}
     if(mode==2)
{
 for (int i = 0; i < NUM_LEDS; i=i+4)
  {
   leds[i] = (CRGB(150, 10,150)); // Розовый цвет.
    FastLED.show();
  }
   }
   if(mode==6)mode=1;
   if(mode==7)mode=1;
 }
//*********************************************************************************************************
//if(pwmled==0){analogWrite(14, 1);} 

delay (100);
  
 irrecv.resume(); // Receive the next value
 digitalWrite(13, LOW);
 
   }//result
}
